#include "boxelworld.h"

float plx=0,ply=0,plz=0,plr=0,plj=0,pry=0;
int plm;

_wbbox *world;

#define WORLD_SIZE 512

#define CLOWD_NUM 1024

void draw_boxels(void);
void draw_cloud(VECTOR pos, VECTOR size);
void DX_CSTRING(int x,int y,int c,char *s);

int boxel_m;

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{
	ChangeWindowMode(TRUE);
	SetMainWindowText("boxelworld 1.0.0");
	SetGraphMode(800,600,32);

	if(DxLib_Init() == -1) return -1;

	SetDrawScreen(DX_SCREEN_BACK);

	ChangeLightTypeDir(VGet(10,-20,-20));

	SetUseZBuffer3D(TRUE);
	SetWriteZBuffer3D(TRUE);
	SetUseBackCulling(TRUE);
	SetCameraNearFar(0.5f, 4000.0f);

	int drw_f = 0;

	plm = MV1LoadModel("resource/models/minecraft_char_1_5.pmd");
	boxel_m = MV1LoadModel("resource/boxel.mqo");

	world = (_wbbox *)malloc(WORLD_SIZE*WORLD_SIZE*sizeof(_wbbox));

	memset(world,0,WORLD_SIZE*WORLD_SIZE*sizeof(_wbbox));

	int mg_c = LoadSoftImage("resource/m_color.bmp");
	FILE *fp = fopen("resource/m_data.dat","rb");

	// <mapgen>
	int x,y;

	for(y=0;y<WORLD_SIZE;y++) {
		for(x=0;x<WORLD_SIZE;x++) {
			int height = 0;
			fread(&height,4,1,fp);
			int i;
			int r,g,b,a;
			GetPixelSoftImage(mg_c,x,y,&r,&g,&b,&a);
			for(i=0;i<height;i++) {
				world[y*WORLD_SIZE+x].boxel[i].color = (r<<16)|(g<<8)|b;
				world[y*WORLD_SIZE+x].boxel[i].use = 1;
			}
		}
	}

	fclose(fp);
	/*FILE *fp = fopen("resource/m_world.dat","rb");
	fread(world,1,WORLD_SIZE*WORLD_SIZE*sizeof(_wbbox),fp);
	fclose(fp);*/
	// </mapgen>

	// <cloudgen>
	VECTOR cloud[CLOWD_NUM][2];
	int i;

	for(i=0;i<CLOWD_NUM;i++) {
		cloud[i][0] = VGet(rand(),1000,rand());
		cloud[i][1] = VGet(rand()%500,20,rand()%500);
	}
	// </cloudgen>

	plx = (WORLD_SIZE/2)*10;
	plz = (WORLD_SIZE/2)*10;

	int ix,iy;
	ix = plx/10;
	iy = plz/10;
	for(i=0;i<128;i++) {
		if(world[iy*WORLD_SIZE+ix].boxel[i].use == 0) break;
	}

	ply = (i+1)*10;

	SetValidMousePointerWindowOutClientAreaMoveFlag(FALSE);
	SetMouseDispFlag(FALSE);

	int bm=400,bn=300;

	SetMousePoint(400,300);

	int mf = 1;
	int khe = 0;

	while(!ProcessMessage()) {
		ClearDrawScreen();

		player_move();

		if(CheckHitKey(KEY_INPUT_ESCAPE)) {
			if(khe == 0) {
				if(mf == 1) {
					SetMouseDispFlag(TRUE);
					SetValidMousePointerWindowOutClientAreaMoveFlag(TRUE);
				} else {
					SetMouseDispFlag(FALSE);
					SetValidMousePointerWindowOutClientAreaMoveFlag(FALSE);
				}

				mf *= -1;
				khe = 1;
			}
		} else {
			khe = 0;
		}

		if(drw_f && mf == 1) {
			DrawBox(0,0,800,600,0x8fcfff,TRUE);

			SetUseLighting(FALSE);

			for(i=0;i<CLOWD_NUM;i++) {
				draw_cloud(cloud[i][0],cloud[i][1]);
			}

			SetUseLighting(TRUE);

			draw_boxels();

			int m,n;

			GetMousePoint(&m,&n);

			plr -= (bm-m)*0.01;
			pry += (bn-n)*0.01;

			if(pry >= 90*3.14/180.0) pry = 90*3.14/180.0;
			if(pry <= -90*3.14/180.0) pry = -90*3.14/180.0;

			SetMousePoint(400,300);

			VECTOR a,b;

			vec_rot(&a,VGet(0,15,0),plr,1);
			vec_rot(&b,VGet(0,0,-1000),pry,0);
			vec_rot(&b,b,plr,1);

			a = VAdd(a,VGet(plx,ply,plz));
			b = VAdd(b,VGet(plx,ply,plz));

			SetCameraPositionAndTarget_UpVecY(a,b);
			

			//MV1SetPosition(plm,VGet(plx,ply,plz));
			//MV1SetRotationXYZ(plm,VGet(0,plr,0));

			//MV1DrawModel(plm);

			show_fps();

			ScreenFlip();
		} else if(drw_f && mf == -1) {
			DX_CSTRING(400,32,0xffffff,"MAIN MENU");

			int m,n;

			GetMousePoint(&m,&n);

			DrawBox(325,275+75,475,325+75,0x007fff,TRUE);
			if(m >= 325 && m < 475 && n > 275+75 && n <= 325+75) DrawBox(325,275+75,475,325+75,0xffffff,TRUE);
			DX_CSTRING(400,300+75,0x000000,"quit");

			DrawBox(325,275-75,475,325-75,0x007fff,TRUE);
			if(m >= 325 && m < 475 && n > 275-75 && n <= 325-75) DrawBox(325,275-75,475,325-75,0xffffff,TRUE);
			DX_CSTRING(400,300-75,0x000000,"return");

			if(m >= 325 && m < 475 && n > 275+75 && n <= 325+75 && (GetMouseInput() & MOUSE_INPUT_LEFT)) { DxLib_End(); return 0; }
			if(m >= 325 && m < 475 && n > 275-75 && n <= 325-75 && (GetMouseInput() & MOUSE_INPUT_LEFT)) { SetMouseDispFlag(FALSE); SetValidMousePointerWindowOutClientAreaMoveFlag(FALSE); mf *= -1; }

			show_fps();

			ScreenFlip();
		}

		drw_f = fps_keep();
	}

	DxLib_End();

	return 0;
}

void DX_CSTRING(int x,int y,int c,char *s)
{
	DrawFormatString(x-GetDrawStringWidth(s,strlen(s))/2,y-8,c,s);
}

int chk_gnd(float *diff)
{
	float x,y;

	x = floor(plx/10.0+0.5);
	y = floor(plz/10.0+0.5);

	*diff = 0;

	int nh = floor(ply/10.0+0.5);

	if(x > WORLD_SIZE || y > WORLD_SIZE || x < 0 || y < 0) return 0;

	if(world[(int)y*WORLD_SIZE+(int)x].boxel[nh].use != 0) { *diff = nh * 10.0+5; }

	return world[(int)y*WORLD_SIZE+(int)x].boxel[nh].use != 0;
}

void draw_cloud(VECTOR pos, VECTOR size)
{
	float x,y,z;
	float a,b,c;

	x=pos.x;
	y=pos.y;
	z=pos.z;

	a=size.x;
	b=size.y;
	c=size.z;

	DrawCube3D(VGet(x-a,y-b,z-c),VGet(x+a,y+b,z+c),0xffffff,0xffffff,TRUE);
}

void draw_boxel(VECTOR pos, int col)
{
	float x,y,z;

	x=pos.x;
	y=pos.y;
	z=pos.z;

	int r,g,b;

	r = (col >> 16) & 0xff;
	g = (col >>  8) & 0xff;
	b = (col >>  0) & 0xff;

	if(!CheckCameraViewClip_Box(VSub(pos,VGet(5,5,5)),VAdd(pos,VGet(5,5,5)))) {
		MV1SetMaterialDifColor(boxel_m, 0, GetColorF((float)r/255.0f, (float)g/255.0f, (float)b/255.0f, 1.0f));
		MV1SetPosition(boxel_m,pos);
		MV1DrawModel(boxel_m);
		//DrawCube3D(VGet(x-5,y-5,z-5),VGet(x+5,y+5,z+5),col,0xffffff,TRUE);
	}
}

#define BOXEL_FAR 100

void draw_boxels(void)
{
	int x,y;

	float px,py;

	px = floor(plx/10.0+0.5);
	py = floor(plz/10.0+0.5);

	int sx,ex,sy,ey;

	sx = px - BOXEL_FAR;
	ex = px + BOXEL_FAR;

	sy = py - BOXEL_FAR;
	ey = py + BOXEL_FAR;

	if(sx < 0) sx = 0;
	if(sy < 0) sy = 0;

	if(ex >= WORLD_SIZE) ex = WORLD_SIZE;
	if(ey >= WORLD_SIZE) ey = WORLD_SIZE;


	for(y=sy;y<ey;y++) {
		for(x=sx;x<ex;x++) {
			float a,b;

			a=x*10.0-plx;
			b=y*10.0-plz;


			if(abs(a) < 10000 && abs(b) < 10000) {
				int i;
				for(i=0;i<128;i++) {
					int a = world[(y+0)*WORLD_SIZE+(x+0)].boxel[i+1].use;
					int b = (y-1 >= 0)? (world[(y-1)*WORLD_SIZE+(x+0)].boxel[i].use):(0);
					int c = (y+1 < WORLD_SIZE)? (world[(y+1)*WORLD_SIZE+(x+0)].boxel[i].use):(0);
					int d = (x+1 < WORLD_SIZE)? (world[(y+0)*WORLD_SIZE+(x+1)].boxel[i].use):(0);
					int e = (x-1 >= 0)? (world[(y+0)*WORLD_SIZE+(x-1)].boxel[i].use):(0);
					int f = (i-1 >= 0)? (world[(y+0)*WORLD_SIZE+(x+0)].boxel[i-1].use):(0);
					if(!(a && b && c && d && e && f))if(world[y*WORLD_SIZE+x].boxel[i].use != 0) draw_boxel(VGet(x*10,i*10,y*10),world[y*WORLD_SIZE+x].boxel[i].color);
				}
			}
		}
	}
}

void blend_anim(int mode)
{
	static float time = 0.0f;
	static int ba = -1;

	if(ba != 0) MV1DetachAnim(plm,ba);


	int ath = MV1AttachAnim(plm,mode,-1,FALSE);

	MV1SetAttachAnimTime(plm,ath,fmod(time,MV1GetAttachAnimTotalTime(plm,ath)));

	time += 1.0;

	ba = ath;
}

void vec_rot(VECTOR *newvertex,VECTOR oldvertex, float angle, int axis)
{
	float cosX, sinX, x, y, z;

	x = oldvertex.x;
	y = oldvertex.y;
	z = oldvertex.z;

	sinX = sin(angle);
	cosX = cos(angle);

	newvertex->x = x;
	newvertex->y = y;
	newvertex->z = z;
	
	switch(axis)
	{
		case 0:
			newvertex->y = y * cosX - z * sinX;
			newvertex->z = y * sinX + z * cosX;
			break;
		case 1:
			newvertex->x = x * cosX + z * sinX;
			newvertex->z = z * cosX - x * sinX;
			break;
		case 2:
			newvertex->x = x * cosX - y * sinX;
			newvertex->y = x * sinX + y * cosX;
			break;
	}
}

void show_fps(void)
{
	static int fps = 0;
	static int frm = 0;
	static int tms = GetNowCount();

	frm++;
	if(GetNowCount() - tms >= 1000) {
		fps = frm;
		frm = 0;
		tms = GetNowCount();
	}
	DrawFormatString(3,3,0x000000,"%d fps",fps);
	DrawFormatString(2,2,0xffffff,"%d fps",fps);
}

int fps_keep(void)
{
	static double diff = 0;
	static int fm_sm = GetNowCount();
	int fm_dm = GetNowCount() - fm_sm;
	int drw_f = 1;

	if(fm_dm > (17-(int)diff)) drw_f = 0;
	else WaitTimer((17-(int)diff) - fm_dm);
	if(diff >= 1.0) diff = 0;
	diff += 17.0-(1000.0/60.0);

	fm_sm = GetNowCount();

	return drw_f;
}